﻿package {

	/*
	copyright Michael Albers, Dortmund,  www.pastorpixel.de
	
	Die PPPoint Klasse ist eine Formelsammlung, welche einige Funktionen
	mit Punkten bereitstellt.
	--------------------------------------------------------------
	winkel(p1:Point, p2:Point):Number;
	gibt den Winkel zurück, den die beiden Punkte innerhalb 
	des Koordinatensystems zueinander einnehmen
	p1 bildet den Nullpunkt
	--------------------------------------------------------------
	turnedPoint(p1:Point, p2:Point, winkel:Number):Point
	
	p1 ist der Nullpunkt, p2 ein zweiter Punkt
	beide Punkte nehmen einen Winkel im Koordinatensystem ein
	es wird als dritter Parameter ein Winkel erwartet 
	
	Wenn man p2 bei gleichem Radius um p1 um diesen Winkel weiterdreht,
	ensteht eine neue Position
	
	es wird ein neuer Punkt zurückgegeben der an dieser gedrehten Position liegt
	--------------------------------------------------------------
	*/

	import flash.geom.Point;

	public class PPPoint {
		
		//----------------------------------------------------------------------

		public function PPPoint() {
		}
		
		//----------------------------------------------------------------------

		public static function winkel(p1:Point, p2:Point):Number {
			var b:Number=p2.x-p1.x;
			var a:Number=p2.y-p1.y;
			var alphaWinkel:Number=(Math.atan(a/b)/Math.PI)*180;
			return alphaWinkel;
		}
		
		//----------------------------------------------------------------------

		public static function turnedPoint(p1:Point, p2:Point, w:Number):Point {
			var radius:Number=Point.distance(p1,p2);
			var alphaWinkel:Number=PPPoint.winkel(p1,p2);
			var zielWinkel:Number=alphaWinkel+w;
			var alphaSin:Number=Math.sin(Math.PI/180*zielWinkel);
			var alphaCos:Number=Math.cos(Math.PI/180*zielWinkel);
			var b:Number=alphaCos*radius+p1.x;
			var a:Number=alphaSin*radius+p1.y;
			var zielPunkt:Point=new Point(b,a);

			return zielPunkt;
		}
		
		//----------------------------------------------------------------------

	}
}