﻿package {
	import flash.display.MovieClip;

	import flash.utils.*;
	import flash.events.*;
	import flash.geom.Point;

	public class Smiley extends MovieClip {

		protected var delay:uint=1000;
		protected var steps:uint=20;
		protected var myTimer:Timer=new Timer(delay,0);
		protected var myMoveTimer:Timer=new Timer((delay/steps),0);
		protected var xPositions:Array;
		protected var yPositions:Array;
		protected var distance:uint=30;
		protected var reset:Boolean=false;


		//--------------------------------------------------------
		public function Smiley() {
			if (stage) {
				init();
			} else {
				addEventListener(Event.ADDED_TO_STAGE,init);
			}
		}

		//-------------------------------------------

		private function init(e:Event=null):void {
			myTimer.addEventListener(TimerEvent.TIMER, TimerUpdate);
			myTimer.start();
			myMoveTimer.addEventListener(TimerEvent.TIMER, moveTimerUpdate);
		}
		//------------------------------------------------

		protected function TimerUpdate(event:TimerEvent):void {

			// eine andere Position kann nur gesetzt werden, bevor die neuen PositionsArrays erstellt werden
			if (reset) {
				this.x=200;
				this.y=200;
				reset=false;
			}

			myMoveTimer.stop();

			var p:Point=getNextPosition();
			trace("xPos: "+this.x+" xZiel: "+p.x);

			var distX:Number=(p.x-this.x)/steps;
			var distY:Number=(p.y-this.y)/steps;

			xPositions = new Array();
			yPositions = new Array();


			xPositions[0]=this.x+distX;
			yPositions[0]=this.y+distY;

			for (var i:uint=1; i<steps; i++) {
				xPositions[i]=xPositions[i-1]+distX;
				yPositions[i]=yPositions[i-1]+distY;
				trace(xPositions[i]);
			}
			myMoveTimer.start();
		}

		protected function moveTimerUpdate(event:TimerEvent):void {
			this.x=xPositions[0];
			xPositions.shift();
			this.y=yPositions.shift();
		}
		//----------------------------------------------

		protected function getNextPosition():Point {
			var dirX:int;
			dirX=Math.floor(Math.random()*3)-1;//-1, 0, 1
			var dirY:int;
			dirY=Math.floor(Math.random()*3)-1;

			// wenn beide Werte 0 sind, ergäbe sich keine neue Position
			if (dirX==0&&dirY==0) {
				getNextPosition();
			}

			var xZiel:Number=this.x+distance*dirX;
			var yZiel:Number=this.y+distance*dirY;

			var zielPoint:Point=new Point(xZiel,yZiel);
			return zielPoint;

		}
		//-----------------------------------------------

		public function resetPosition():void {
			reset=true;
		}


	}
}